Subject: Linux Distributions and the Shadow Password Suite
From: [email-masked] (John F. Haugh II)
Date: 18 Jan 1994 21:42:14 +0200
Newsgroups: comp.os.linux.announce

I just read Richard Stallman's article regarding the GPL and CD-ROM
distributions and felt now was the time for a note of my own regarding
the inclusion of the Shadow Password Suite code into Linux.

Numerous FAQ postings state that Linux is distributed under the terms
of the GNU General Public License.  As most Linux distributions which
I am aware of contain significant quantities of code for which I am
the copyright owner, this is a false statement.  The copyright which
covers the Shadow Password Suite permits "free" distribution in a
sense which is opposite to that of the GPL and which was written with
the express purpose of prohibiting commercial distributions of the
type I am now finding to be quite commonplace.

The copyright on Shadow 3.2.3 (which I understand is one of the most
common levels of Shadow code) states

	Copyright 1989, 1990, 1991, 1992, 1993, John F. Haugh II
	All rights reserved.

	Permission is granted to copy and create derivative works for any
	non-commercial purpose, provided this copyright notice is preserved
	in all copies of source code, or included in human readable form
	and conspicuously displayed on all copies of object code or
	distribution media.

Note that only non-commercial distribution is permitted.  Resellers of
Linux who are charging above and beyond the actual cost of transmission
are violating the copyright.  This is as stated in the README file for
3.2.3.

The GPL permits "free" distribution in the sense that anyone can distribute
the code, and if they distribute it to a third party, that person is also
assured of the right to distribute the code.  The copyright on Shadow
permits "free" distribution in the sense that you cannot charge for the
code.  You can give it away, you can put it on an FTP server and let people
connect anonymously, or you could copy it onto CD-ROMs and charge your
customers what the CD pressing company charges you.  What you cannot do
is (this is not an exhaustive list) put it onto a CD-ROM and charge more
than actual cost of the CD-ROM, put it on an FTP server and charge for
copying the source code, or use it as part of a value-added package in a
hardware offering.

It is true that at one time Shadow was going to be placed under the GPL but
philosophical differences prevented this from occuring.

The purpose of the copyright was to prevent the type of problems which
recently occured with changes made to the shadow.c functions.  If you aren't
allowed to sell Shadow as a product, you are much more likely to send bug
reports to me, and much less likely to get something hacked on by someone
who is not completely familiar with the code.  The largest philosophical
difference I had with the FSF people was in control over the design and
functional integrity of the shadow code.  Several well-intentioned but
mis-guided changes to Shadow have proven this was a sound decision.

I have been corresponding with a number of distributors for the purpose
of bringing them into compliance with the terms and conditions of Shadow.
I hope to bring all of the commercial distributors of Shadow into
compliance in an attempt to prevent the problems which have occured in the
past and to dispell the misinformation that surrounds those portions of
Linux which I authored.  In the meantime, I'd like it if the FAQ's would
be amended to remove any claims that Linux as a whole is covered by the
GPL.  From all indications, none of the most popular distributions are.
-- 
John F. Haugh II  [ NRA-ILA ] [ Kill Barney ] !'s: ...!cs.utexas.edu!rpp386!jfh
Ma Bell: (512) 251-2151     [ DoF #17 ] [ PADI ]     @'s: [email-masked]
The P.C. Movement killed the 1st Amendment, the Brady Bill the 2nd, the WOsD
got the 4th and 5th, political activism the 9th and 10th.  Not much left, eh?

--
Mail submissions for comp.os.linux.announce to: [email-masked]
PLEASE remember Keywords: and a short description of the software.